/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>



#define VER                 "0.1.1"
#define KEYPATH1            "Software\\Delphino\\QuickFTP\\Connections"
#define KEYPATH2            "Software\\Delphino\\QuickFTP"
#define BUFFSZ              4096



void doquery(HKEY key, u_char *buff, u_char *value);
void qftp_dec(u_char *pwd);



int main(void) {
    HKEY    key;
    u_char  buff[BUFFSZ];
    int     i,
            len;


    setbuf(stdout, NULL);

    fputs("\n"
        "Delphino QuickFTP passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    fputs("\n"
        "Accounts\n"
        "========\n", stdout);
    if(RegOpenKeyEx(HKEY_CURRENT_USER, KEYPATH1, 0, KEY_READ, &key)) {
        fputs("\nError: registry key has not been found\n", stdout);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }
    i = 0;
    while(1) {
        fputc('\n', stdout);

        sprintf(buff, "%dA", i);
        doquery(key, buff, buff);
        printf("Connection:   %s\n", buff);

        sprintf(buff, "%dB", i);
        doquery(key, buff, buff);
        printf("Server:       %s:", buff);

        sprintf(buff, "%dF", i);
        doquery(key, buff, buff);
        printf("%s\n", buff);

        sprintf(buff, "%dC", i);
        doquery(key, buff, buff);
        printf("Path:         %s\n", buff);

        sprintf(buff, "%dE", i);
        doquery(key, buff, buff);
        qftp_dec(buff);
        printf("Password:     %s\n", buff);

        i++;
    }
    RegCloseKey(key);

    if(RegOpenKeyEx(HKEY_CURRENT_USER, KEYPATH2, 0, KEY_READ, &key)) {
        fputs("\nError: registry key has not been found\n", stdout);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }
    if(!RegQueryValueEx(
        key,
        "pwd",
        NULL,
        NULL,
        buff,
        (void *)&len)) {
        qftp_dec(buff);
        printf("\nProxy Password:   %s\n", buff);
    }
    RegCloseKey(key);

    fputs("\n    Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



void doquery(HKEY key, u_char *buff, u_char *value) {
    int     len = BUFFSZ;

    if(RegQueryValueEx(
      key,
      value,
      NULL,
      NULL,
      buff,
      (void *)&len)) {
        fputs("\nError: impossible to read the registry key\n", stdout);
        fputs("\n    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }
}



void qftp_dec(u_char *pwd) {
    int     ecx,
            i = 1;

    while(*pwd) {
        ecx = *pwd - 0x75 - (i * 12);
        if(ecx < 0) ecx--;
        *pwd++ = ecx;
        i++;
    }
}

